#include <bits/stdc++.h>

using namespace std;

int resultNum(vector<long long int> a, long long int n) {
    int temp;
    int result = 0;
    long long int iter = n - 1;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < iter; j++) {
            if(a[j] > a[j + 1]) {
                temp = a[j];
                a[j] = a[j + 1];
                a[j + 1] = temp;

                result++;
            }
        }
    }

    return result;
}

int resultPair(vector<long long int> a, long long int n) {
    int temp;
    long long int iter = n - 1;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < iter; j++) {
            if(a[j] > a[j + 1]) {
                temp = a[j];
                a[j] = a[j + 1];
                a[j + 1] = temp;

                cout << j + 1 << " " << j + 2 << endl;
            }
        }
    }

    return 0;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long int n;
    cin >> n;

    vector<long long int> a(n);
    for(long long int i = 0; i < n; i++)
        cin >> a[i];

    long long int temp;
    long long int result = 0;
    vector<pair<long long int, long long int>> change;

    cout << resultNum(a, n) << endl;
    resultPair(a, n);
}